#ifndef CUBE_HPP_INCLUDED
#define CUBE_HPP_INCLUDED


#include"impr_area.hpp"
#include"drawer.hpp"
#include"pixelmap.hpp"




namespace cube{


enum class FrameID{
  top_back,
  top_left,
  top_right,
  top_front,

  front_left,
  front_right,
  front_bottom,
  front_top,

  right_right,
  right_left,
  right_bottom,
  right_top,

};



void  draw_frame(Drawer&  dr, int  x, int  y, Dir  dir);


extern PixelMap<pixel16_t>  pixelmap_;


void  reset();

void    fill_top_plane(PixelMap16&  dst, pixel16_t  pixel, int  x=0, int  y=0);
void  fill_front_plane(PixelMap16&  dst, pixel16_t  pixel, int  x=0, int  y=0);
void  fill_right_plane(PixelMap16&  dst, pixel16_t  pixel, int  x=0, int  y=0);

void    fill_top_plane(Drawer&  dst, pixel16_t  pixel, int  x=0, int  y=0);
void  fill_front_plane(Drawer&  dst, pixel16_t  pixel, int  x=0, int  y=0);
void  fill_right_plane(Drawer&  dst, pixel16_t  pixel, int  x=0, int  y=0);

}




#endif




