#include"krtdb.hpp"




namespace krtdb{




Header::
Header(std::string&&  name, ValueKind  valuekind):
name_(std::move(name)),
valuekind_(valuekind)
{}


Header::
Header(const Header&  rhs):
name_(rhs.name_),
valuekind_(rhs.valuekind_)
{}


Header::
Header(Header&&  rhs):
name_(std::move(rhs.name_)),
valuekind_(rhs.valuekind_)
{}




bool
Header::
operator==(const Header&  rhs) const
{
  return((name_      == rhs.name_     ) &&
         (valuekind_ == rhs.valuekind_));
}




}




