#ifndef KRTDB_VALUEKIND_HPP_INCLUDED
#define KRTDB_VALUEKIND_HPP_INCLUDED


#include<cstdint>


namespace krtdb{


enum class
ValueKind
{
  null,

  bool_,
  int8_,
  uint8_,
  int16_,
  uint16_,
  int32_,
  uint32_,
   vlint_,
  uvlint_,

  string,
  binary,
  table,
  record,

};


const char*  get_value_kind_string(ValueKind  kind);


}




#endif




