#ifndef PALETTE_HPP_INCLUDED
#define PALETTE_HPP_INCLUDED


#include<string>
#include"pixel.hpp"
#include"drawer.hpp"




class Stream;


struct
ColorElement
{
  static const int  width ;
  static const int  height;

  static void  draw(Drawer&  dr, void*  data, int  i, int  x, int  y);

};


struct
ColorEntry
{
  pixel16_t  pixel;

  ColorEntry(): pixel(0){}


  static const int  width ;
  static const int  height;

  static void  draw(Drawer&  dr, void*  data, int  i, int  x, int  y);

};


struct
Palette
{
  enum{
    color_number = 16,
  };


  ColorEntry  entries[color_number];

  Palette(){}

  void  save(Stream&  s) const;
  void  load(Stream&  s)      ;

};




#endif




