#ifndef UTF_HPP
#define UTF_HPP


#include<cstdint>
#include<string>


size_t   u16strlen(const char16_t*  str);

size_t   get_utf8_bytes(const char*  s);
size_t  get_utf8_length(const char*  s);

char16_t  get_unicode(const char*&  utf8);

std::u16string  to_u16string(const std::string&     s);
std::string        to_string(const std::u16string&  u16s);

size_t  push_utf8(std::string&  s, char16_t  c);




#endif




