#include"world.hpp"
#include"fileio.hpp"


using namespace krtdb;


namespace{
const char*
path = "__WORLD.db";
}


void
World::
load()
{
  auto  f = fopen(path,"rb");

    if(f)
    {
      FileStream  fs(f);

      Storage  st;

      st.read(fs);

//      auto&  player_table = st.get_table("players");
      auto&   block_table = st.get_table("blocks");
      auto&  figure_table = st.get_table("figures");

/*
      std::vector<MenuItem*>  items;

      auto&  records = player_table.get_records();

        for(auto&  p: records)
        {
          items.emplace_back(new Player(p.second,st,audio_device_));
        }


      player_menu->move(items);
*/
    }
}


void
World::
save() const
{
  Storage  st;

//  auto&  player_table = st.new_table("heaps",Heap::tabledef);
  auto&   block_table = st.new_table("blocks",  Block::tabledef);
//  auto&  figure_table = st.new_table("figures",Figure::tabledef);

/*
    for(auto  item: player_menu->get_items())
    {
      auto  pl = static_cast<const Heap*>(item);

        if(pl)
        {
          auto&  rec = player_table.new_record();

          pl->save(rec,st);
        }
    }
*/

  MemoryStream  mems;

//  st.print();

  st.write(mems);

  auto&  buf = mems.get_buffer();

  save_file(buf.data(),buf.size(),path);
//  save_gzfile(buf.data(),buf.size(),"world.duff");
}




