#include"world.hpp"




enum class ItemID{
  heap,
  rename,
  remove,
//  view,
  save,
  END,
};


/*
struct
World::ManageMenuHandle
{
  static void  decide_space(const MenuHandler&  handler, void*  userdata);
  static void  cancel_space(const MenuHandler&  handler, void*  userdata);
  static void  decide_manage(const MenuHandler&  handler, void*  userdata);
};


void
World::ManageMenuHandle::
decide_manage(const MenuHandler&  handler, void*  userdata)
{
  auto&  wd = *(World*)userdata;

    switch((ItemID)handler.get_y_position())
    {
      case(ItemID::heap):
      case(ItemID::rename):
      case(ItemID::remove):
//      case(ItemID::view):
        wd.push_menu_handler(wd.player_menu_handler);
        break;
      case(ItemID::save):
        wd.save();

        wd.display_timer = 80;
        break;
      default:;
    }
}


void
World::ManageMenuHandle::
decide_space(const MenuHandler&  handler, void*  userdata)
{
  auto&  wd = *(World*)userdata;

    switch((ItemID)wd.manage_menu_handler.get_y_position())
    {
      case(ItemID::heap):
        wd.current_player = static_cast<Player*>(wd.player_menu_handler.get());

          if(wd.current_player)
          {
            wd.reset_edit();
          }

        else
          {
            auto  newp = new Player(wd.space_parameter,wd.audio_device_);

            wd.player_menu_handler.insert(newp);

            wd.current_player = newp;
          }
        break;
      case(ItemID::rename):
        wd.current_player = static_cast<Player*>(wd.player_menu_handler.get());

          if(wd.current_player)
          {
            wd.reset_naming();
          }
        break;
      case(ItemID::remove):
        wd.player_menu_handler.insert(nullptr);
        break;
      default:;
    }
}


void
World::ManageMenuHandle::
cancel_space(const MenuHandler&  handler, void*  userdata)
{
  auto&  wd = *(World*)userdata;

    switch((ItemID)wd.manage_menu_handler.get_y_position())
    {
      case(ItemID::heap):
      case(ItemID::rename):
      case(ItemID::remove):
//      case(ItemID::view):
        wd.pop_menu_handler();
        break;
      default:;
   }
}




*/
void
World::
initialize_manage()
{
  manage_menu += {TextMenu::Item(u"積む..."),
                  TextMenu::Item(u"名前を変更..."),
                  TextMenu::Item(u"削除..."),
                  TextMenu::Item(u"すべて保存"),
                 };


//  player_menu.reset(new Menu(1,10,side_length*2+(font_w*12)+8,side_length*2+8));
/*
  manage_menu_handler.reset(*manage_menu,  0,0,{std::make_pair(MenuAction::decide,ManageMenuHandle::decide_manage)},this);
  player_menu_handler.reset(*player_menu,320,0,{std::make_pair(MenuAction::decide,ManageMenuHandle::decide_space),
                                                std::make_pair(MenuAction::cancel,ManageMenuHandle::cancel_space)},this);

  push_menu_handler(manage_menu_handler);

  load();
*/
}


void
World::
render_manage()
{
  auto  dr = video_device_->get_drawer();

  manage_menu.draw(dr);
//  player_menu.draw(dr);

    if(display_timer)
    {
      --display_timer;

      dr.draw_ascii("saved",to_pixel32(white_color),0,dr.get_height()-font_h);
    }
}




void
World::
input_manage(Controller&  ctrl)
{
    if(test_key_timer(6) && ctrl.is_pressing_any())
    {
      set_flag(redraw_flag);
    }
}




