#ifndef BLOCK_HPP_INCLUDED
#define BLOCK_HPP_INCLUDED


#include"impr_space.hpp"
#include"krtdb.hpp"
#include"cube.hpp"
#include"heap.hpp"
#include"rep.hpp"




class
Block: public Object
{
  friend class Loader;

public:
  Block();

  void  update();

  void  draw(PixelMap16&  pixmap, int  x, int  y) const;
  void  draw(Drawer&  dr, int  x, int  y) const;

  static const krtdb::TableDef  tabledef;

  void  load(const krtdb::Record&  rec, const krtdb::Storage&  sto)      ;
  void  save(      krtdb::Record&  rec,       krtdb::Storage&  sto) const;

};




#endif




