#include"block_buffer.hpp"




namespace{


std::vector<Block*>
stack;


}


int
BlockBuffer::
size()
{
  return stack.size();
}


void
BlockBuffer::
push(Object*  obj, Space::Signal  sig)
{
    if(obj)
    {
      auto  blk = static_cast<Block*>(obj);

        switch(sig)
        {
          case(Space::Signal::release):
            blk->clear();

            stack.emplace_back(blk);
            break;
          case(Space::Signal::update):
            blk->update();
            break;
        }
    }
}


Object*
BlockBuffer::
pop_object()
{
  return pop();
}





Block*
BlockBuffer::
pop()
{
  Block*  ptr;

    if(stack.size())
    {
      ptr = stack.back();

      stack.pop_back();
    }

  else
    {
      ptr = new Block;
    }


  return ptr;
}




