#include"controller.hpp"




Controller::
Controller()
{
   pressing_state = 0;
    pressed_state = 0;
  unpressed_state = 0;
        other_key = 0;
}


bool  Controller::is_pressing_any() const{return pressing_state;}
bool  Controller::test_pressing(  Key  flag) const{return(pressing_state &flag);}
bool  Controller::test_pressed(   Key  flag) const{return(pressed_state  &flag);}
bool  Controller::test_unpressed( Key  flag) const{return(unpressed_state&flag);}


void
Controller::
press(Key  flag)
{
    if(!(pressing_state&flag))
    {
      pressed_state |= flag;
    }


  pressing_state |= flag;
}


void
Controller::
unpress(Key  flag)
{
    if(pressing_state&flag)
    {
      unpressed_state |= flag;
    }


  pressing_state &= ~flag;
}


void
Controller::
clear()
{
    pressed_state = 0;
  unpressed_state = 0;
}




