#ifndef CONTROLLER_HPP_INCLUDED
#define CONTROLLER_HPP_INCLUDED


#include<cstdint>


enum
Key
{
      p_flag=  1,
      n_flag=  2,
     up_flag=  4,
   left_flag=  8,
  right_flag= 16,
   down_flag= 32,
  shift_flag= 64,
  start_flag=128,
  other_flag=256,

};



class
Controller
{
  uint32_t   pressing_state;
  uint32_t    pressed_state;
  uint32_t  unpressed_state;

public:
  uint32_t  other_key;

  Controller();

  bool  is_pressing_any() const;
  bool    test_pressing(Key  flag) const;
  bool     test_pressed(Key  flag) const;
  bool   test_unpressed(Key  flag) const;

  void    press(Key  flag);
  void  unpress(Key  flag);

  void  clear();

};




#endif





