#ifndef FILEIO_HPP
#define FILEIO_HPP


#include<string>
#include<cstddef>
#include<cstdio>
#include<vector>




void    save_file(const void*  src_data, size_t  src_size, const char*  path, bool  backup=false);
void  save_gzfile(const void*  src_data, size_t  src_size, const char*  path, bool  backup=false);


std::string    load_file(const char*  path);
std::string  load_gzfile(const char*  path);




#endif




