#include"impr.hpp"




void
Point2D::
set(int  _x, int  _y)
{
  x = _x;
  y = _y;
}



bool
Point3D::
operator==(const Point3D&  rhs) const
{
  return((x == rhs.x) &&
         (y == rhs.y) &&
         (z == rhs.z));
}


void
Point3D::
set(int  _x, int  _y, int  _z)
{
  x = _x;
  y = _y;
  z = _z;
}


void
Point3D::
convert_isometrically(Point2D&  point, const Point3D*  offset_point) const
{
  int  tmp_x = x;
  int  tmp_y = y;
  int  tmp_z = z;

    if(offset_point)
    {
      tmp_x -= offset_point->x;
      tmp_y -= offset_point->y;
      tmp_z -= offset_point->z;
    }


  point.x = ((tmp_x   )-(tmp_y   )        );
  point.y = ((tmp_y>>1)+(tmp_x>>1)-(tmp_z));
}




