#ifndef IMPR_POINT_HPP
#define IMPR_POINT_HPP


#include<cstdint>




struct Point2D;


struct
Point3D
{
  int  x;
  int  y;
  int  z;

  constexpr Point3D(int  _x=0, int  _y=0, int  _z=0): x(_x), y(_y), z(_z){}

  bool  operator==(const Point3D&  rhs) const;

  void  set(int  _x, int  _y, int  _z);

  void  convert_isometrically(Point2D&  point, const Point3D*  offset_point=nullptr) const;

};


struct
Point2D
{
  int  x;
  int  y;

  constexpr Point2D(int  _x=0, int  _y=0): x(_x), y(_y){}
  constexpr Point2D(Point3D  pt):
  x(pt.x-pt.y),
  y((pt.y/2)+(pt.x/2)-pt.z)
  {}

  void  set(int  _x, int  _y);

};




#endif




