#include"impr.hpp"




const Rect3D&
Space::
get_view_rect() const
{
  return view_rect;
}


void
Space::
set_view_point(int  x, int  y, int  z)
{
  view_rect.x = x;
  view_rect.y = y;
  view_rect.z = z;
}


void
Space::
move_view_left(int  dist)
{
  view_rect.x -= dist;

    if(view_rect.x < 0)
    {
      view_rect.x = 0;
    }
}


void
Space::
move_view_right(int  dist)
{
  view_rect.x += dist;

    if((view_rect.x+view_rect.x_width) > size_.x_width)
    {
      view_rect.x = (size_.x_width-view_rect.x_width);
    }
}


void
Space::
move_view_back(int  dist)
{
  view_rect.y -= dist;

    if(view_rect.y < 0)
    {
      view_rect.y = 0;
    }
}


void
Space::
move_view_front(int  dist)
{
  view_rect.y += dist;

    if((view_rect.y+view_rect.y_width) > size_.y_width)
    {
      view_rect.y = (size_.y_width-view_rect.y_width);
    }
}


void
Space::
move_view_top(int  dist)
{
  view_rect.z += dist;

    if((view_rect.z+view_rect.height) > size_.height)
    {
      view_rect.z = (size_.height-view_rect.height);
    }
}


void
Space::
move_view_bottom(int  dist)
{
  view_rect.z -= dist;

    if(view_rect.z < 0)
    {
      view_rect.z = 0;
    }
}




