#include"krtdb.hpp"
#include<random>




using namespace krtdb;




int
main(int  argc, char**  argv)
{
  Storage  st;

  const char*  path = "test.db";

  auto  f = fopen(path,"rb");

    if(!f)
    {
      f = fopen(path,"wb");

      FileStream  fs(f);

      auto&  table = st.new_table("TestTable",TableDef({Header("Number"),Header("String",ValueKind::string),Header("Bool",ValueKind::bool_)}));

      auto&  rec = table.new_record();

      rec.values_[0] = Value(876543210);
      rec.values_[1] = Value("aeiou");
      rec.values_[2] = Value(true);

      st.print();

      st.write(fs);
    }

  else
    {
      FileStream  fs(f);

      st.read(fs);

      st.print();
    }


  return 0;
}




