#ifndef FRAME_HPP
#define FRAME_HPP


#include"widget.hpp"
#include"textboard.hpp"
#include<initializer_list>
#include<vector>
#include<string>


class
Frame: public Widget
{
  std::u16string  caption_;

  int  center_position_;

public:
  Frame();
  Frame(const std::u16string&  caption, std::initializer_list<Widget*>  widgets, int  margin=0);


  void  reset(const std::u16string&  caption, std::initializer_list<Widget*>  widgets, int  margin=0);

  void  draw(Drawer&  dr);

};


#endif




